from graphics_and_games_klassen import Rechteck, Dreieck, Kreis, Ereignisbehandlung
import time
class Dame:
    """
    Stellt eine Dame auf der Grafikoberfläche dar.
    """
    def __init__(self):
        """
        Erzeugt die Einzelteile der Dame.
        """
        self.x = 50
        self.y = 50
        self.basis = Rechteck()
        self.basis.FarbeSetzen("orange")
        self.basis.GroesseSetzen(40, 10)
        self.zacke1 = Dreieck()
        self.zacke1.FarbeSetzen("orange")
        self.zacke1.GroesseSetzen(10, 20)
        self.zacke2 = Dreieck()
        self.zacke2.FarbeSetzen("orange")
        self.zacke2.GroesseSetzen(10, 20)
        self.zacke3 = Dreieck()
        self.zacke3.FarbeSetzen("orange")
        self.zacke3.GroesseSetzen(10, 20)
        self.zacke4 = Dreieck()
        self.zacke4.FarbeSetzen("orange")
        self.zacke4.GroesseSetzen(10, 20)
        self.kreis1 = Kreis()
        self.kreis1.FarbeSetzen("orange")
        self.kreis1.RadiusSetzen(2)
        self.kreis2 = Kreis()
        self.kreis2.FarbeSetzen("orange")
        self.kreis2.RadiusSetzen(2)
        self.kreis3 = Kreis()
        self.kreis3.FarbeSetzen("orange")
        self.kreis3.RadiusSetzen(2)
        self.kreis4 = Kreis()
        self.kreis4.FarbeSetzen("orange")
        self.kreis4.RadiusSetzen(2)
        self.PositionSetzen(0, 0)

    def Anordnen(self):
        """
        Ordnet die Teile gemäß der Position an.
        """
        self.basis.PositionSetzen(self.x + 5, self.y + 35)
        self.zacke1.PositionSetzen(self.x + 10, self.y + 15)
        self.zacke2.PositionSetzen(self.x + 20, self.y + 15)
        self.zacke3.PositionSetzen(self.x + 30, self.y + 15)
        self.zacke4.PositionSetzen(self.x + 40, self.y + 15)
        self.kreis1.PositionSetzen(self.x + 10, self.y + 13)
        self.kreis2.PositionSetzen(self.x + 20, self.y + 13)
        self.kreis3.PositionSetzen(self.x + 30, self.y + 13)
        self.kreis4.PositionSetzen(self.x + 40, self.y + 13)

    def PositionSetzen(self, zeile, spalte):
        """
        Setzt die Position auf dem Schachbrett.
        Das Brett hat links oben die Koordinaten (50|50).
        """
        self.x = 50 + spalte * 50
        self.y = 400 - zeile * 50
        self.Anordnen()

    def SichtbarkeitSetzen(self, sichtbar):
        """
        Steuert die Sichtbarkeit der Dame.
        """
        self.basis.SichtbarkeitSetzen(sichtbar)
        self.zacke1.SichtbarkeitSetzen(sichtbar)
        self.zacke2.SichtbarkeitSetzen(sichtbar)
        self.zacke3.SichtbarkeitSetzen(sichtbar)
        self.zacke4.SichtbarkeitSetzen(sichtbar)
        self.kreis1.SichtbarkeitSetzen(sichtbar)
        self.kreis2.SichtbarkeitSetzen(sichtbar)
        self.kreis3.SichtbarkeitSetzen(sichtbar)
        self.kreis4.SichtbarkeitSetzen(sichtbar)



class Schachbrett:
    """
    Verwaltet das Schachbrett und die Damen.
    """
    def __init__(self, groesse):
        """
        Legt das Schachbrett und die Damen an.
        """
        self.brett = [[Rechteck() for _ in range(groesse)] for _ in range(groesse)]
        for zeile in range(groesse):
            for spalte in range(groesse):
                self.brett[zeile][spalte].GroesseSetzen(50, 50)
                self.brett[zeile][spalte].PositionSetzen(50 + spalte * 50, 400 - zeile * 50)
                self.brett[zeile][spalte].FarbeSetzen("schwarz" if (spalte + zeile) % 2 == 0 else "weiss")

    def SichtbarkeitSetzen(self, sichtbar):
        """
        Steuert die Sichtbarkeit des Schachbretts.
        """
        for zeile in range(groesse):
            for spalte in range(groesse):
                self.brett[zeile][spalte].SichtbarkeitSetzen(sichtbar)
                
class Damen(Ereignisbehandlung):
    """
    Löst das Problem der x Damen.
    """
    def __init__(self, x):
        """
        Legt das Schachbrett an.
        """
        super().__init__()
        self.weiter = False
        self.schachbrett = [[False for _ in range(x)] for _ in range(x)]
        self.brett = Schachbrett(x)
        self.damen = []
        for zeile in range(x):
            dame = Dame()  # Erstelle ein neues Dame-Objekt
            dame.SichtbarkeitSetzen(False)  # Setze die Sichtbarkeit auf unsichtbar
            self.damen.append(dame)  # Füge die Dame zur Liste hinzu
        self.SchrittAusführen(0)
        
    def TasteGedrueckt(self, taste):
        """
        Aktionsmethode, die bei jedem Tastendruck ausgelöst wird.
        -- Parameter taste gedrückte Taste
        """
        self.weiter = True

    def IstFeldBedroht(self, zeile, spalte):
        """
        Testet, ob das angegebene Element des Schachbretts durch eine der bisher aufgestellten Damen bedroht ist.
        """
        aktspalte = spalte - 1
        while aktspalte >= 0:
            if self.schachbrett[zeile][aktspalte]:
                return True
            aktspalte -= 1

        aktspalte = spalte - 1
        aktzeile = zeile - 1
        while aktspalte >= 0 and aktzeile >= 0:
            if self.schachbrett[aktzeile][aktspalte]:
                return True
            aktspalte -= 1
            aktzeile -= 1

        aktspalte = spalte - 1
        aktzeile = zeile + 1
        while aktspalte >= 0 and aktzeile < len(self.schachbrett):
            if self.schachbrett[aktzeile][aktspalte]:
                return True
            aktspalte -= 1
            aktzeile += 1
        return False

    def LösungAusgeben(self):
        """
        Gibt die gefundene Lösung aus.
        """
        while(not self.weiter):
            time.sleep(1)
        self.weiter = False

    def SchrittAusführen(self, spalte):
        """
        Macht einen Rekursionsschritt auf dem Weg zur Lösung.
        """
        self.damen[spalte].SichtbarkeitSetzen(True)
        for zeile in range(len(self.schachbrett)):
            if not self.IstFeldBedroht(zeile, spalte):
                self.damen[spalte].PositionSetzen(zeile, spalte)
                self.schachbrett[zeile][spalte] = True
                if spalte == len(self.schachbrett) - 1:
                    self.LösungAusgeben()
                else:
                    self.SchrittAusführen(spalte + 1)
                self.schachbrett[zeile][spalte] = False
        self.damen[spalte].SichtbarkeitSetzen(False)
        
        
d = Damen(8)
d.LösungAusgeben()
